diff -uwr sourceold/scripts/PhysicalGameObj.h source/scripts/PhysicalGameObj.h
--- sourceold/scripts/PhysicalGameObj.h	2011-10-11 21:49:03.425781200 +0800
+++ source/scripts/PhysicalGameObj.h	2012-02-17 16:57:48.055664000 +0800
@@ -109,7 +109,7 @@
 	bool				Is_HUD_Pokable_Indicator_Enabled( void )		{ return HUDPokableIndicatorEnabled; } 
 	virtual void		Set_Player_Type(int type);
 	virtual void	Object_Shattered_Something(PhysClass * observed_obj, PhysClass * shattered_obj, int surface_type);
-	void                Clear_Animation() {AnimControl->Set_Mode(ANIM_MODE_STOP,0);ClearAnimation = true;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);}
+	void                Clear_Animation() {if (AnimControl) {AnimControl->Set_Mode(ANIM_MODE_STOP,0);ClearAnimation = true;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);}}
 protected:
 	ActiveConversationClass *ActiveConversation;
 private:
diff -uwr sourceold/scripts/RawFileClass.h source/scripts/RawFileClass.h
--- sourceold/scripts/RawFileClass.h	2011-10-11 21:48:07.639648400 +0800
+++ source/scripts/RawFileClass.h	2012-01-01 06:32:39.293953200 +0800
@@ -129,18 +129,9 @@
 			Close();
 			return true;
 		}
-		else
-		{
-			Handle = CreateFileA(Filename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
-			if (Handle == INVALID_HANDLE_VALUE)
-				return false;
-			
-			if (!CloseHandle(Handle))
-				Error(GetLastError(),0,Filename);
 			
-			Handle = INVALID_HANDLE_VALUE;
-		}
-		return true;
+		int attr = GetFileAttributesA(Filename);
+		return attr != INVALID_FILE_ATTRIBUTES && !(attr & FILE_ATTRIBUTE_DIRECTORY);
 	}
 	bool Is_Open()
 	{
@@ -169,7 +160,7 @@
 			Handle = CreateFileA(Filename,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
 			break;
 		case 1:
-			Handle = CreateFileA(Filename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
+			Handle = CreateFileA(Filename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,0);
 			break;
 		case 0:
 			Handle = CreateFileA(Filename,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
diff -uwr sourceold/scripts/SimpleFileFactoryClass.cpp source/scripts/SimpleFileFactoryClass.cpp
--- sourceold/scripts/SimpleFileFactoryClass.cpp	2011-10-11 23:06:14.933593700 +0800
+++ source/scripts/SimpleFileFactoryClass.cpp	2012-01-01 06:32:39.259773500 +0800
@@ -105,11 +105,7 @@
 				{
 					new_name.Format("%s%s", token, stripped_name);
 					file->Set_Name(new_name);
-					if (file->Open(1))
-					{
-						file->Close();
-						break;
-					}
+					if (file->Is_Available(0)) break;
 				}
 			}
 			else
diff -uwr sourceold/scripts/SoldierGameObj.h source/scripts/SoldierGameObj.h
--- sourceold/scripts/SoldierGameObj.h	2011-10-13 11:34:11.870117100 +0800
+++ source/scripts/SoldierGameObj.h	2012-02-23 16:37:06.592773400 +0800
@@ -179,6 +179,8 @@
 	bool Can_Steal_Vehicles() { return CanStealVehicles; }
 	void Set_Can_Drive_Vehicles(bool onoff) { CanDriveVehicles = onoff; Set_Object_Dirty_Bit(BIT_RARE, true); }
 	bool Can_Drive_Vehicles() { return CanDriveVehicles; }
+	void Set_Block_Action_Key(bool onoff) { BlockActionKey = onoff; Set_Object_Dirty_Bit(BIT_RARE, true); }
+	bool Block_Action_Key() { return BlockActionKey; }
 protected:
 	RenderObjClass		*	WeaponRenderModel; //2416
 	RenderObjClass		*	BackWeaponRenderModel; //2420
@@ -234,6 +236,7 @@
 	bool						CanDriveVehicles; // padding
 	PersistantSurfaceEmitterClass * WaterWake; //3376
 	DynamicVectorClass<RenderObjClass*>	RenderObjList; //3380
+	bool                        BlockActionKey;
 	void						Add_RenderObj( RenderObjClass * obj );
 	RenderObjClass *		Find_RenderObj( const char * name );
 	void						Reset_RenderObjs( void );
diff -uwr sourceold/scripts/SoldierGameObjDef.h source/scripts/SoldierGameObjDef.h
--- sourceold/scripts/SoldierGameObjDef.h	2011-10-11 21:43:34.199218700 +0800
+++ source/scripts/SoldierGameObjDef.h	2012-02-13 17:49:26.127351500 +0800
@@ -33,6 +33,7 @@
 	DECLARE_EDITABLE( SoldierGameObjDef, SmartGameObjDef );
 	float Get_Skeleton_Height() {return SkeletonHeight;};
 	float Get_Skeleton_Width() {return SkeletonWidth;};
+	bool Is_Spy() const {return IsSpy;}
 protected:
 	float											TurnRate;
 	float											JumpVelocity;
@@ -47,6 +48,9 @@
 	int											HumanAnimOverrideDefID;
 	int											HumanLoiterCollectionDefID;
 	int											DeathSoundPresetID;
+	bool						CanStealVehicles;
+	bool						CanDriveVehicles;
+	bool                        IsSpy;
 	friend	class								SoldierGameObj;
 	friend	class								SoldierObserverClass;
 	friend class PresetDump;
diff -uwr sourceold/scripts/Sound3DClass.h source/scripts/Sound3DClass.h
--- sourceold/scripts/Sound3DClass.h	2011-10-11 21:43:32.148437500 +0800
+++ source/scripts/Sound3DClass.h	2012-02-17 15:02:45.628906200 +0800
@@ -62,6 +62,7 @@
 	virtual void                Set_Max_Vol_Radius      (float);
 	virtual float               Get_Max_Vol_Radius      ();
 	virtual float               Get_DropOff_Radius      ();
+	virtual unsigned long       Get_Class_ID            () const { return CLASSID_3D; }
 	void Update_Edge_Volume();
 };
 
diff -uwr sourceold/scripts/TranslateDBClass.cpp source/scripts/TranslateDBClass.cpp
--- sourceold/scripts/TranslateDBClass.cpp	2011-12-02 08:44:42.934570300 +0800
+++ source/scripts/TranslateDBClass.cpp	2012-01-11 20:59:06.598632800 +0800
@@ -222,6 +222,25 @@
 		obj->Set_String(TranslateDBClass::Get_Current_Language(), L"High Resolution Shadows");
 		Add_Object(obj);
 	}
+
+	TDBObjClass* texture_filter = Find_Object("IDS_TEXTURE_FILTER");
+	if (texture_filter)
+	{
+		char* en_string = (char*)texture_filter->Get_English_String().Peek_Buffer();
+		if (char* en_star = strrchr(en_string, '*')) *en_star = ' ';
+
+		wchar_t* lang_string = (wchar_t*)texture_filter->Get_String().Peek_Buffer();
+		if (wchar_t* lang_star = wcsrchr(lang_string, L'*')) *lang_star = L' ';
+	}
+
+	if (!Find_Object("IDS_ANTIALIAS_MODE"))
+	{
+		TDBObjClass* obj = new TDBObjClass();
+		obj->Set_ID_Desc("IDS_ANTIALIAS_MODE");
+		obj->Set_English_String("Anti-aliasing Mode:");
+		obj->Set_String(TranslateDBClass::Get_Current_Language(), L"Anti-aliasing Mode:");
+		Add_Object(obj);
+	}
 	if (!Find_Object("IDS_STRUCT_GUARD_TOWER"))
 	{
 		TDBObjClass* obj = new TDBObjClass();
diff -uwr sourceold/scripts/VehicleGameObj.h source/scripts/VehicleGameObj.h
--- sourceold/scripts/VehicleGameObj.h	2011-10-13 16:09:05.123046800 +0800
+++ source/scripts/VehicleGameObj.h	2012-02-13 17:13:11.633210900 +0800
@@ -52,7 +52,7 @@
 	virtual Matrix3D	Get_Look_Transform(void);
 	bool					Has_Turret( void)						{ return TurretBone != 0; }
 	virtual VehicleGameObj		* As_VehicleGameObj()		{ return this; }
-	virtual	bool	Is_Aircraft( void )						{ return Get_Definition().Type == VEHICLE_TYPE_FLYING; }
+	virtual	bool	Is_Aircraft( void )						{ return Get_Definition().Type == VEHICLE_TYPE_FLYING || Get_Definition().Type == VEHICLE_TYPE_SUB; }
 	virtual  bool  Is_Turret( void )							{ return Get_Definition().Type == VEHICLE_TYPE_TURRET; }
 	virtual int Get_Player_Type(void) const;
 	virtual	void	Apply_Damage_Extended( const OffenseObjectClass & offense, float scale = 1.0f,
@@ -113,20 +113,20 @@
 	void					Ignore_Occupants( void );
 	void					Unignore_Occupants( void );
 	SoldierGameObj *Get_Occupant(int seat) {return SeatOccupants[seat];}
-	void Set_Is_Scripts_Visible(bool b) {SCRIPTS_visible = b;}
-	bool Get_Is_Scripts_Visible() {return SCRIPTS_visible;}
-	void Set_Scripts_Last_Team(char c) {SCRIPTS_LastTeam = c;}
-	void Set_Scripts_Can_Fire(bool b) {SCRIPTS_CanFire = b;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_FREQUENT,true);}
-	bool Get_Scripts_Can_Fire() { return SCRIPTS_CanFire; };
-	void Set_Allow_Stealth_While_Empty(bool onoff) { SCRIPTS_AllowStealthWhileEmpty = onoff; Set_Object_Dirty_Bit(BIT_RARE, true); };
-	bool Get_Allow_Stealth_While_Empty() const { return SCRIPTS_AllowStealthWhileEmpty; };
-	void Damage_Meshes_Update() {SCRIPTS_DamageMeshesUpdate = true; Set_Object_Dirty_Bit(NetworkObjectClass::BIT_FREQUENT,true);}
+	void Set_Is_Scripts_Visible(bool b) {visible = b;}
+	bool Get_Is_Scripts_Visible() {return visible;}
+	void Set_Scripts_Last_Team(char c) {LastTeam = c;}
+	void Set_Scripts_Can_Fire(bool b) {CanFire = b;Set_Object_Dirty_Bit(NetworkObjectClass::BIT_FREQUENT,true);}
+	bool Get_Scripts_Can_Fire() { return CanFire; };
+	void Set_Allow_Stealth_While_Empty(bool onoff) { AllowStealthWhileEmpty = onoff; Set_Object_Dirty_Bit(BIT_RARE, true); };
+	bool Get_Allow_Stealth_While_Empty() const { return AllowStealthWhileEmpty; };
+	void Damage_Meshes_Update() {DamageMeshesUpdate = true; Set_Object_Dirty_Bit(NetworkObjectClass::BIT_FREQUENT,true);}
 	void Set_Occupant(int seat, SoldierGameObj *occupant) {SeatOccupants[seat] = occupant;}
 	bool Is_Underground() {return Peek_Physical_Object()->Get_Collision_Group() == UNDERGROUND_COLLISION_GROUP;}
 	void Set_Immovable(bool b) {Peek_Physical_Object()->Set_Immovable(b);Set_Object_Dirty_Bit(NetworkObjectClass::BIT_FREQUENT,true);}
 	bool Is_Immovable() {return Peek_Physical_Object()->Is_Immovable();}
-	void Set_Lock_Team(int team) {SCRIPTS_LockTeam = (char)team;Set_Object_Dirty_Bit(BIT_RARE,true);} //0 = nod, 1 = gdi, 2 = both
-	int Get_Lock_Team() {return SCRIPTS_LockTeam;}
+	void Set_Lock_Team(int team) {LockTeam = (char)team;Set_Object_Dirty_Bit(BIT_RARE,true);} //0 = nod, 1 = gdi, 2 = both
+	int Get_Lock_Team() {return LockTeam;}
 	void Set_Can_Be_Stolen(bool onoff) { CanBeStolen = onoff; Set_Object_Dirty_Bit(BIT_RARE, true); }
 	bool Can_Be_Stolen() const { return CanBeStolen; }
 	void Set_Owner(SoldierGameObj *obj) {Owner = obj;}
@@ -146,8 +146,8 @@
 		bool enemy = false;
 		if (obj != this)
 		{
-			int sTeamID1 = SCRIPTS_LastTeam;
-			if (SCRIPTS_LastTeam == -2)
+			int sTeamID1 = LastTeam;
+			if (LastTeam == -2)
 			{
 				sTeamID1 = Get_Player_Type();
 			}
@@ -173,8 +173,8 @@
 	bool Scripts_Is_Teammate(const DamageableGameObj* oObject);
 	bool Scripts_Is_Team_Player()
 	{
-		int team = SCRIPTS_LastTeam;
-		if (SCRIPTS_LastTeam == -2)
+		int team = LastTeam;
+		if (LastTeam == -2)
 		{
 			team = Get_Player_Type();
 		}
@@ -202,9 +202,9 @@
 	bool						HasExitTransitions; //2450
 	bool						VehicleDelivered; //2451
 	bool						DriverIsGunner; //2452
-	bool                        SCRIPTS_visible; //2453
-	char                        SCRIPTS_LastTeam; //2454
-	bool						SCRIPTS_DamageMeshesUpdate; //2455
+	bool                        visible; //2453
+	char                        LastTeam; //2454
+	bool						DamageMeshesUpdate; //2455
 	VectorClass<PersistantSurfaceEmitterClass *>	WheelSurfaceEmitters; //2456
 	PersistantSurfaceSoundClass *						WheelSurfaceSound; //2472
 	enum {
@@ -216,9 +216,9 @@
 	DynamicVectorClass<TransitionInstanceClass *> TransitionInstances; //2496
 	ReferencerClass		LockOwner; //2520
 	float						LockTimer; //2536
-	bool				SCRIPTS_CanFire;
-	bool				SCRIPTS_AllowStealthWhileEmpty;
-	char                SCRIPTS_LockTeam;
+	bool				CanFire;
+	bool				AllowStealthWhileEmpty;
+	char                LockTeam;
 	bool				CanBeStolen;
 	UndergroundEffectClass *UndergroundEffect;
 	ReferencerClass     Owner; //Owner for SSGM vehicle locking. When this is set, only this player can enter the vehicle.
diff -uwr sourceold/scripts/VehicleGameObjDef.h source/scripts/VehicleGameObjDef.h
--- sourceold/scripts/VehicleGameObjDef.h	2011-10-11 21:40:51.412109300 +0800
+++ source/scripts/VehicleGameObjDef.h	2012-02-13 17:16:25.394929700 +0800
@@ -31,6 +31,8 @@
 	VEHICLE_TYPE_BIKE,
 	VEHICLE_TYPE_FLYING,
 	VEHICLE_TYPE_TURRET,
+	VEHICLE_TYPE_BOAT,
+	VEHICLE_TYPE_SUB,
 } VehicleType;
 class VehicleGameObjDef : public SmartGameObjDef
 {
@@ -72,6 +74,8 @@
 	int NodDamageReportID;
 	int GDIDestroyReportID;
 	int NodDestroyReportID;
+	bool CanBeStolen;
+	bool AllowStealthWhileEmpty;
 	friend	class								VehicleGameObj;
 	friend class PresetDump;
 }; // size: 324
diff -uwr sourceold/scripts/WWAudioClass.h source/scripts/WWAudioClass.h
--- sourceold/scripts/WWAudioClass.h	2011-12-08 11:43:52.664062500 +0800
+++ source/scripts/WWAudioClass.h	2012-02-17 15:02:45.624023400 +0800
@@ -176,9 +176,9 @@
 	AudibleSoundClass *		Create_Sound_Effect (FileClass &file, const char *string_id);
 	SHADERS_API AudibleSoundClass *		Create_Sound_Effect (const char *filename);
 	AudibleSoundClass *		Create_Sound_Effect (const char *string_id, unsigned char *raw_wave_data, unsigned long bytes);
-	Sound3DClass *		Create_3D_Sound (FileClass &file, const char *string_id, int classid_hint = CLASSID_3D);
+	SHADERS_API Sound3DClass *		Create_3D_Sound (FileClass &file, const char *string_id, int classid_hint = CLASSID_3D);
 	SHADERS_API Sound3DClass *		Create_3D_Sound (const char *filename, int classid_hint = CLASSID_3D);
-	Sound3DClass *		Create_3D_Sound (const char *string_id, unsigned char *raw_wave_data, unsigned long bytes, int classid_hint = CLASSID_3D);
+	SHADERS_API Sound3DClass *		Create_3D_Sound (const char *string_id, unsigned char *raw_wave_data, unsigned long bytes, int classid_hint = CLASSID_3D);
 	SHADERS_API void						Set_Background_Music (const char *filename);
 	SHADERS_API void						Fade_Background_Music (const char *filename, int fade_out_time, int fade_in_time);
 	const char *			Get_Background_Music_Name (void)						{ return m_BackgroundMusicName; }
@@ -200,7 +200,7 @@
 	bool					Set_Cache_Size (int kbytes = DEF_CACHE_SIZE)	{ m_MaxCacheSize = (kbytes * 1024); }
 	int					Get_Cache_Size (void) const						{ return m_MaxCacheSize / 1024; }
 	int					Get_Current_Cache_Size (void) const				{ return m_CurrentCacheSize; }
-	void					Flush_Cache (void);
+	SHADERS_API void					Flush_Cache (void);
 	void					Set_Max_2D_Sound_Buffer (int bytes = DEF_MAX_2D_BUFFER_SIZE)	{ m_Max2DBufferSize = bytes; }
 	void					Set_Max_3D_Sound_Buffer (int bytes = DEF_MAX_3D_BUFFER_SIZE)	{ m_Max3DBufferSize = bytes; }
 	SHADERS_API bool					Simple_Play_2D_Sound_Effect (const char *filename, float priority = 1.0F, float volume = DEF_SFX_VOL);
@@ -229,13 +229,13 @@
 	AudibleSoundClass *	Peek_2D_Sample (int index);
 	AudibleSoundClass *	Peek_3D_Sample (int index);
 	void					Free_Completed_Sounds (void);
-protected:
+public:
 	void						Build_3D_Driver_List (void);
 	void						Free_3D_Driver_List (void);
 	void						Reprioritize_Playlist (void);
 	bool						Validate_3D_Sound_Buffer (SoundBufferClass *buffer);
-	FileClass *				Get_File (LPCTSTR filename);
-	void						Return_File (FileClass *file);
+	SHADERS_API FileClass *				Get_File (LPCTSTR filename);
+	SHADERS_API void						Return_File (FileClass *file);
 	void						Allocate_2D_Handles (void);
 	void						Release_2D_Handles (void);
 	void						Allocate_3D_Handles (void);
@@ -256,7 +256,7 @@
 	SoundBufferClass *	Find_Cached_Buffer (const char *string_id);
 	SoundBufferClass *	Create_Sound_Buffer (FileClass &file, const char *string_id, bool is_3d);
 	SoundBufferClass *	Create_Sound_Buffer (unsigned char *file_image, unsigned long bytes, const char *string_id, bool is_3d);
-	bool						Cache_Buffer (SoundBufferClass *buffer, const char *string_id);
+	SHADERS_API bool						Cache_Buffer (SoundBufferClass *buffer, const char *string_id);
 	bool						Free_Cache_Space (int bytes);
 	static unsigned int AILCALLBACK	File_Open_Callback (char const *filename, unsigned int *file_handle);
 	static void AILCALLBACK	File_Close_Callback (unsigned int file_handle);
@@ -267,7 +267,7 @@
 	static HANDLE									_TimerSyncEvent;
 	typedef struct _CACHE_ENTRY_STRUCT
 	{
-		char *					string_id;
+		const char *					string_id;
 		SoundBufferClass *	buffer;
 		_CACHE_ENTRY_STRUCT (void)
 			: string_id (0), buffer (NULL) {}
diff -uwr sourceold/scripts/anticheat.ini source/scripts/anticheat.ini
--- sourceold/scripts/anticheat.ini	2011-12-05 15:24:43.332539100 +0800
+++ source/scripts/anticheat.ini	2012-02-18 13:32:47.225585900 +0800
@@ -51,3 +51,65 @@
 cbc396725a03305b6b6f5ce7ea699b17=always3.dat
 fc9931e6588e44d620ba233caf4004c8=mnatr_mct.w3d
 5bc57e1d26b07fd553a703c18616f405=mnatr_mct.w3d
+27a4e37ebdd5989ecc6c2febeb41a815=C&C_city.ldd
+f522b6e776d66f1af982be51a188bf0b=C&C_city.lsd
+8b46187317e1631c5ed2b8008614efdf=C&C_city_flying.ldd
+e8d4b43aa05dcfa36b7e0fe40bfa1eee=C&C_complex.ldd
+708e3e537949b222ea535523cf28cd3c=C&C_complex.lsd
+e1ec1e2f15cbc0c77ab774213340d593=C&C_field.ldd
+8894e0982c621148e49bcec0e811b44d=C&C_field.lsd
+7cff234cc5770145c048f76ab04cae4f=C&C_hourglass.ldd
+051eac32f238cfca12b09b329984817e=C&C_hourglass.lsd
+a6e38a8c403e64ef045f54c837ecd703=C&C_islands.ldd
+95aaf1f05560d799626e3ecc7a94ca00=C&C_islands.lsd
+62fcaa2c128c739cd858ee724a8b7318=C&C_mesa.ldd
+9d318a4c494e3b2a83d2156b9e59eb0f=C&C_mesa.lsd
+4ed16fa604eb023fb6434d5ae463ae31=C&C_under.ldd
+bd8961e3368ed6f90c3588d09c3356be=C&C_under.lsd
+94b910a88765391f2244e1213cca4a78=C&C_volcano.ldd
+a1e1547777f69d68a6cd2e0756584345=C&C_volcano.lsd
+21ae0b50c5a03a2b63d4519254864225=C&C_walls.ldd
+b5a5cd52300c492756b2209cf384adad=C&C_walls.lsd
+91ba633531aab87fdf7d165eb528b496=C&C_walls_flying.ldd
+a916c2f47497773d345baf8c31ec03ef=mp_field.w3d
+e299223ff777fde6d508bff2593ffd81=mp_mesa_lm.w3d
+3f9cdcd5576519d0437bf341d88a92f9=tunnels_lm.w3d
+7bfafa8c50b1795d2b68fecb75f7cda9=C&C_City.mix
+5ca54f39d7df2585638e9277cfa4e16a=C&C_City_Flying.mix
+9cd91d03f98eea3ba462b142aaf5d065=C&C_Complex.mix
+62c97bd41d190db869a920371cdf1640=C&C_Field.mix
+6c2b667b0a2a127bc65f9c4c5ca8cefb=C&C_Hourglass.mix
+73d3084febd0c16eb205e5466c7d575d=C&C_Islands.mix
+e401d506bc1adb522f502a62e7dc549c=C&C_Mesa.mix
+3a53501d162216aefc3f9d32821d83e0=C&C_Under.mix
+988d9deef7ff334f820babf5d65e6206=C&C_Volcano.mix
+9781e5da5947c6330d69a014c7210b25=C&C_Walls.mix
+b42b40e536d8b017b73f165dbb20a3b8=C&C_Walls_Flying.mix
+0433e1a057ab4ca3ec65faa85ed2a948=C&C_city.ldd
+11e8091c3e8c90c181efd256b8806400=C&C_city.lsd
+fc1ab2a0d9d3be3092d79f0d94ca4206=C&C_city_flying.ldd
+aa78fd99f6ff9229822c6aba4fb207bb=C&C_complex.ldd
+0916776a78095929f9c145e57d2b7c76=C&C_complex.lsd
+c76f552fd199226efd0c01c460ca25a0=C&C_field.ldd
+7be222a0de09fd7ac58421b0664a4442=C&C_field.lsd
+edf001f39f301b4224e38bbde383a0db=C&C_hourglass.ldd
+7d0d0804644c9a2e46203de975198294=C&C_hourglass.lsd
+7841b23042a2df76ec951568ca3bbb94=C&C_islands.ldd
+049cfb804de44740c9267cde3a2f5956=C&C_islands.lsd
+40b33a3fbe1ee1d2bc8135565a8dea62=C&C_mesa.ldd
+1230513b03ebf712244ee7ef18ae6a79=C&C_mesa.lsd
+71e812b99b1b8b91c2d6726ff013922d=C&C_under.ldd
+f7722090212438fb9284f3b9ec13ea2f=C&C_under.lsd
+942a8f4613bad737d6b22f38300eb35b=C&C_volcano.ldd
+191c8d5e89adab3203caab54851fcc31=C&C_volcano.lsd
+9abb0a7bfdd4d879546361207df58b97=C&C_walls.ldd
+00ff9e4b60e98424a33c85ab849a190e=C&C_walls.lsd
+c10e1e6df79683fdd954273b1bfa4858=C&C_walls_flying.ldd
+0ea282c6c570845ad5a39ec7c82ad553=mp_field.w3d
+357ba78da453e6811ddefb805bbf939a=mp_mesa_lm.w3d
+fd8a854fe08761d16fa429595b322780=tunnels_lm.w3d
+07fcfef552d405ff768299c5ef7d6ee5=always3.dat
+4531ac11b7fe2566aace69763da0689e=builtin.shd
+909e932deec23ec75da3744306051b83=builtin_fxaa_sm3_hq.fxo
+1e7fca47542d374462af2fb81ec8a87c=builtin_fxaa_sm3_mq.fxo
+96d98d3a8dc579e76d9b57798a093936=builtin_fxaa_sm3_lq.fxo
Only in source/scripts: d3dx9.h
diff -uwr sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2011-11-07 21:18:01.975585900 +0800
+++ source/scripts/dllmain.cpp	2012-02-27 12:49:54.797328100 +0800
@@ -297,6 +297,8 @@
 	AddThinkHook = (allh)Address(tt,"AddThinkHook");
 	AddPlayerJoinHook = (apjh)Address(tt,"AddPlayerJoinHook");
 	AddRadioHook = (arch)Address(tt,"AddRadioHook");
+	AddStockDamageHook = (asdh)Address(tt,"AddStockDamageHook");
+	AddTtDamageHook = (atdh)Address(tt,"AddTtDamageHook");
 	GetCurrentMusicTrack = (gcmt)Address(tt,"GetCurrentMusicTrack");
 	Set_Info_Texture = (sit)Address(tt,"Set_Info_Texture");
 	Clear_Info_Texture = (cit)Address(tt,"Clear_Info_Texture");
@@ -344,6 +346,7 @@
 	AddPlayerLeaveHook = (aplh)Address(tt,"AddPlayerLeaveHook");
 	GetExplosionObj = (geo)Address(tt,"GetExplosionObj");
 	SetExplosionObj = (seo)Address(tt,"SetExplosionObj");
+	Update_Network_Object = (uno)Address(tt,"Update_Network_Object");
 	gttv GetTTVersion = (gttv)Address(tt,"GetTTVersion");
 	Commands->Control_Enable = (void(*)( GameObject * obj, bool enable ))Address(tt,"New_Control_Enable");
 	AddShaderNotify = (asn)Address(tt,"AddShaderNotify");
@@ -386,13 +389,13 @@
 	Send_Custom_All_Players = (scap)Address(tt,"Send_Custom_All_Players");
 	Steal_Team_Credits = (stc)Address(tt,"Steal_Team_Credits");
 	Get_Team_Credits = (gtc)Address(tt,"Get_Team_Credits");
-	Set_Objects_Filename = (ssn)Address(tt,"Set_Objects_Filename");
 	addConnectionAcceptanceFilter = (addConnectionAcceptanceFilterType)Address(tt, "addConnectionAcceptanceFilter");
 	removeConnectionAcceptanceFilter = (removeConnectionAcceptanceFilterType)Address(tt, "removeConnectionAcceptanceFilter");
 	Evict_Client = (ec)Address(tt,"Evict_Client");
 	Get_Current_Map_Index = (gcmi)Address(tt,"Get_Current_Map_Index");
 	Get_Player_List = (gpl)Address(tt,"Get_Player_List");
 	Get_Map = (gm)Address(tt,"Get_Map");
+	Get_Map_Count = (gmc)Address(tt,"Get_Map_Count");
 	Set_Map = (smx)Address(tt,"Set_Map");
 	Get_Game_Definitions = (ggd)Address(tt,"Get_Game_Definitions");
 	Get_Client_Serial_Hash = (gcsh)Address(tt,"Get_Client_Serial_Hash");
diff -uwr sourceold/scripts/dp88_ar.cpp source/scripts/dp88_ar.cpp
--- sourceold/scripts/dp88_ar.cpp	2011-12-01 12:13:35.659179600 +0800
+++ source/scripts/dp88_ar.cpp	2012-02-23 12:06:21.704101500 +0800
@@ -1320,7 +1320,7 @@
 	// If AI miner health drops below the emergency chronoshift health threshold and we are driving to
 	// the ore field or collecting ore then begin an emergency chronoshift
 	if ( useAI && Commands->Get_Health(obj) < (Commands->Get_Max_Health(obj)*(Get_Float_Parameter("emergencyChronoshiftHealthThreshold")/100.0f))
-		&& (aiState == MINER_AISTATE_DRIVE_TO_ORE || aiState == MINER_AISTATE_COLLECTING_ORE) )
+		&& (aiState == MINER_AISTATE_COLLECTING_ORE && oreLoadLevel > 0) )
 	{
 		// Attempt to start a chronoshift - if it fails don't bother
 		// with anything else, driving away won't help...
@@ -1822,18 +1822,23 @@
 	switch(animstate)
 	{
 	case 0:
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 		break;
 	case 1:
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
 		break;
 	case 2:
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
 		break;
 	case 3:
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
 		break;
 	case 4:
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), false, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
 		break;
 	}
@@ -2017,8 +2022,8 @@
 		GameObject* pilot = Commands->Find_Object(pilotID);
 		if ( pilot )
 		{
-			Commands->Control_Enable ( Commands->Find_Object ( pilotID ), true );
-			Commands->Give_Money( Commands->Find_Object( pilotID ), (float)(Get_Int_Parameter ( "cost" )), 0 );
+			Commands->Control_Enable ( pilot, true );
+			Commands->Give_Money( pilot, (float)(Get_Int_Parameter ( "cost" )), 0 );
 		}
 		pilotID = NULL;
 
diff -uwr sourceold/scripts/dp88_ar_unitScripts.cpp source/scripts/dp88_ar_unitScripts.cpp
--- sourceold/scripts/dp88_ar_unitScripts.cpp	2011-10-22 21:53:45.732421800 +0800
+++ source/scripts/dp88_ar_unitScripts.cpp	2012-02-02 17:58:48.974609300 +0800
@@ -616,13 +616,15 @@
 
 void dp88_AR_Tesla_Coil::Timer_Expired ( GameObject* obj, int number )
 {
+	if (number == TIMER_TESLACOIL_DECREMENT_CHARGE)
+	{
 	if ( m_chargeLevel > 0 )
 		m_chargeLevel--;
 
 	// Have we dropped out of supercharged status?
 	if ( m_isSupercharged && !((Is_Base_Powered(Get_Object_Type(obj)) && m_chargeLevel >= m_chargesSupercharge) || m_chargeLevel >= m_chargesPowerOn + m_chargesSupercharge) )
 		setSuperchargedState(obj, false);
-
+	}
 
 	// Call base class timer expired
 	dp88_AI_Turret::Timer_Expired(obj, number);
diff -uwr sourceold/scripts/dp88_buildingScripts.cpp source/scripts/dp88_buildingScripts.cpp
--- sourceold/scripts/dp88_buildingScripts.cpp	2011-12-01 12:48:42.641601500 +0800
+++ source/scripts/dp88_buildingScripts.cpp	2012-02-23 12:06:21.652343700 +0800
@@ -21,6 +21,7 @@
 #include "AirFactoryGameObj.h"
 #include "RefineryGameObj.h"
 #include "PurchaseSettingsDefClass.h"
+#include "PhysicalGameObj.h"
 
 /*------------------------
 Building Controller Script
@@ -551,10 +552,12 @@
 {
 	if (animstate == 0 && Get_Int_Parameter("animLoop"))
 	{
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
 	}
 	if (animstate == 1 && Get_Int_Parameter("destroyedAnimLoop"))
 	{
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), false, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
 	}
 }
diff -uwr sourceold/scripts/dp88_misc.cpp source/scripts/dp88_misc.cpp
--- sourceold/scripts/dp88_misc.cpp	2011-12-01 11:52:12.948242100 +0800
+++ source/scripts/dp88_misc.cpp	2012-02-23 12:06:21.224609300 +0800
@@ -14,7 +14,8 @@
 #include "dp88_custom_timer_defines.h"
 #include "definition.h"
 #include "VehicleGameObj.h"
-
+#include "SoldierGameObj.h"
+#include "SoldierGameObjDef.h"
 
 
 /*------------------------
@@ -383,8 +384,8 @@
 
 void dp88_unitSounds::Created ( GameObject* obj )
 {
+	Update_Network_Object(obj);
 	healAmount = 0;
-
 	if ( strcmp ( Get_Parameter ( "createdSound" ), "null" ) != 0 && Is_Valid_Preset ( Get_Parameter ( "createdSound" ) ) )
 		Commands->Create_3D_Sound_At_Bone( Get_Parameter ( "createdSound" ), obj, "origin" );
 
@@ -693,6 +694,7 @@
 
 void dp88_damageAnimation::SetDamageAnimation ( GameObject* obj )
 {
+	obj->As_PhysicalGameObj()->Clear_Animation();
 	if ( basePowerState || damageLevelLowPowerStartFrames[currentDamageLevel] < 0 )
 		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)damageLevelStartFrames[currentDamageLevel], (float)damageLevelEndFrames[currentDamageLevel], false );
 	else
@@ -1340,7 +1342,7 @@
 	float money = ((bRepair) ? repairMoney : damageMoney) * amount;
 
 	// Is this player an APB spy?
-	bool bSpy = ( Find_Script_On_Object(damager, "RA_Infantry_Spy") != NULL );
+	bool bSpy = Is_Spy(damager);
 
 	// Repaired other team or damaged own team? That would be negative points and no
 	// money for you then... unless your spy, then the logic is inverted...
diff -uwr sourceold/scripts/engine_3dre.h source/scripts/engine_3dre.h
--- sourceold/scripts/engine_3dre.h	2011-11-07 15:17:05.800781200 +0800
+++ source/scripts/engine_3dre.h	2012-01-01 06:32:39.324226700 +0800
@@ -552,16 +552,19 @@
 void _DebugEventEnd(); //End a debug event
 void _DebugEventMarker(D3DCOLOR color, wchar_t *message,...); //Add a debug marker
 int _DebugGetStatus(); //Get debug status
+void _DebugNameObject(IDirect3DResource9* object, const char* name); // Name a D3D object
 #ifdef DEBUG
 #define DebugEventStart(...)	_DebugEventStart(__VA_ARGS__)
 #define DebugEventMarker(...)	_DebugEventMarker(__VA_ARGS__)
 #define DebugEventEnd()			_DebugEventEnd()
 #define DebugGetStatus()		_DebugGetStatus()
+#define DebugNameObject(object, name) _DebugNameObject(object, name)
 #else
 #define DebugEventStart(...)
 #define DebugEventMarker(...)
 #define DebugEventEnd()
 #define DebugGetStatus()
+#define DebugNameObject(object, name)
 #endif
 Vector4 GetColorVector4(D3DCOLOR color); //Converts a D3DCOLOR into a Vector4
 Vector3 GetColorVector3(D3DCOLOR color); //Converts a D3DCOLOR into a Vector3
diff -uwr sourceold/scripts/engine_common.cpp source/scripts/engine_common.cpp
--- sourceold/scripts/engine_common.cpp	2011-10-11 23:03:34.733398400 +0800
+++ source/scripts/engine_common.cpp	2012-01-11 22:18:19.132812500 +0800
@@ -171,6 +171,11 @@
 	return Exe;
 };
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 SCRIPTS_API void* HookupAT3(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
 {
 	static const char relJumpOp = '\xE9';					
diff -uwr sourceold/scripts/engine_io.cpp source/scripts/engine_io.cpp
--- sourceold/scripts/engine_io.cpp	2011-10-13 01:39:18.449218700 +0800
+++ source/scripts/engine_io.cpp	2012-01-01 06:32:39.322273500 +0800
@@ -70,7 +70,7 @@
 		ini->Get_String("paths","RegFDS","RenegadeFDS",RegFDS,MAX_PATH);
 		ini->Get_String("paths","FileBase","Renegade",FileBase,MAX_PATH);
 		ini->Get_String("paths","FileClient","Client",FileClient,MAX_PATH);
-		ini->Get_String("paths","","FDS",FileFDS,MAX_PATH);
+		ini->Get_String("paths","FileFDS","FDS",FileFDS,MAX_PATH);
 		UseRenFolder = ini->Get_Bool("paths","UseRenFolder",UseRenFolder);
 		Release_INI(ini);
 	}
diff -uwr sourceold/scripts/engine_io.h source/scripts/engine_io.h
--- sourceold/scripts/engine_io.h	2011-10-12 09:16:50.970703100 +0800
+++ source/scripts/engine_io.h	2012-01-01 06:32:39.285164200 +0800
@@ -147,7 +147,7 @@
 csave.End_Micro_Chunk();
 #define WRITE_MICRO_CHUNK_WWSTRING(csave,id,string) \
 csave.Begin_Micro_Chunk(id); \
-csave.Write(string.Peek_Buffer(),string.Get_Length() + 1); \
+csave.Write(string.Peek_Buffer(),sizeof(*string.Peek_Buffer())*(string.Get_Length() + 1)); \
 csave.End_Micro_Chunk();
 #define WRITE_WWSTRING_CHUNK(csave,id,string) \
 csave.Begin_Chunk(id); \
diff -uwr sourceold/scripts/engine_obj.cpp source/scripts/engine_obj.cpp
--- sourceold/scripts/engine_obj.cpp	2011-10-14 22:25:11.520507800 +0800
+++ source/scripts/engine_obj.cpp	2012-02-17 21:03:32.721679600 +0800
@@ -224,6 +224,8 @@
 #ifdef SHADERS_EXPORTS
 SHADERS_API SList<C4GameObj> GameObjManager::C4GameObjList;
 SHADERS_API SList<BeaconGameObj> GameObjManager::BeaconGameObjList;
+SHADERS_API SList<SoldierGameObj> GameObjManager::SoldierGameObjList;
+SHADERS_API SList<VehicleGameObj> GameObjManager::VehicleGameObjList;
 #endif
 
 const BaseGameObjDef &	BaseGameObj::Get_Definition( void ) const 
@@ -1482,12 +1484,6 @@
 	PhysObj->Set_Transform(tm);
 }
 
-RENEGADE_FUNCTION
-void PhysicalGameObj::Post_Think()
-AT2(0x006A5770, 0x006A5010);
-
-
-
 bool DamageableGameObj::Is_Teammate(DamageableGameObj * p_obj)
 {
 	return ((p_obj == this) || (Is_Team_Player() && Get_Player_Type() == p_obj->Get_Player_Type()));
diff -uwr sourceold/scripts/engine_obj2.cpp source/scripts/engine_obj2.cpp
--- sourceold/scripts/engine_obj2.cpp	2011-10-22 13:31:31.273437500 +0800
+++ source/scripts/engine_obj2.cpp	2012-02-13 18:26:42.375398400 +0800
@@ -660,4 +660,13 @@
 	return ( ActionCode != NULL );
 }
 
+bool SCRIPTS_API Is_Spy(GameObject *obj)
+{
+	if (obj->As_SoldierGameObj())
+	{
+		return obj->As_SoldierGameObj()->Get_Definition().Is_Spy();
+	}
+	return false;
+}
+
 REF_DEF2(SmartGameObj::GlobalSightRangeScale,float,0x00811E64,0x0081103C);
